local down = love.keyboard.isDown
local gr = love.graphics
Timer = require "hump.timer"
--player collison box
gravity = 500
player = { x=50,y=50,w=28,h=28 , vx = 500}
player.onGround = false
player.hasJumped = false


function playerload()
  PlayerJumpTimer = Timer.new()
	--player collison box
	world:add(player, player.x,player.y,player.w,player.h)
	--actual player look
	playerlayer = map.layers["player"]
	playerlayer.player = {
		x = player.x,
		y = player.y,
		w = player.w,
		h = player.h
	}
  playerlayer.player.facing = "left"
	function playerlayer:update(dt)

	end

	-- actual player draw
	function playerlayer:draw()
		local x = math.floor(self.player.x)
		local y = math.floor(self.player.y)
		gr.setColor(255,255,255)
		love.graphics.rectangle('fill',self.player.x,self.player.y,self.player.w,self.player.h)
	end
end
function playerupdate(dt)
	updatePlayer(dt)
  PlayerJumpTimer:update(dt)
	--player collision box attached to actual player
	playerlayer.player.x = player.x
	playerlayer.player.y = player.y


end
function playerdraw()
	--draw Player Collision box
	drawBox(player, 0,255,0)
end

--player collision box update
function updatePlayer(dt)
  local vx = player.vx
  
  dx, dy = 0, 0
  if player.hasJumped == false then
  dy = gravity * dt
  end

  if love.keyboard.isDown('d') then
    dx = vx * dt
    playerlayer.player.facing = "left"
  elseif love.keyboard.isDown('a') then
    dx = -vx * dt
    playerlayer.player.facing = "right"
  end

if player.hasJumped == true then
  dy = -gravity * dt
end





  if dx ~= 0 or dy ~= 0 then
    player.onGround = false
    local future_l, future_t = player.x + dx, player.y + dy
    local cols, len = world:check(player, future_l, future_t)
  
    if len == 0 then
      player.x, player.y = future_l, future_t
      world:move(player, future_l, future_t)
      
    else
      local col, tl, tt, nx, ny, sl, st
      while len > 0 do
        col = cols[1]
        tl,tt,nx,ny,sl,st = col:getSlide()
        PlayercheckIfOnGround(ny)
        if player.onGround then 
          dy = 0
        end
        if ny > 0 then 
          player.hasJumped = false
        end
        player.x, player.y = tl, tt
        world:move(player, tl, tt)
        cols, len = world:check(player, sl, st)
        if len == 0 then

          player.x, player.y = sl, st
          world:move(player, sl, st)
        end
      end
    end
  end

end
function PlayercheckIfOnGround(ny)
  if ny < 0 then 
    player.onGround = true 
  end
end
function playerkeypressed(key)
  if key == " " then
    if player.hasJumped == false and player.onGround then
      player.hasJumped = true
      PlayerJumpTimer:add(.25, function() player.hasJumped = false end)
    end
  end
end
